import java.util.Objects;

public class Clickable {
    private final int MAX_VALUE = 9999;
    private int counter;

    public Clickable() {
        init();
    }

    public void init() {
        this.counter = 0;
    }

    public void click() {
        this.counter = (this.counter + 1) % this.MAX_VALUE;
    }

    public int value() {
        return this.counter;
    }

    public String toString() {
        return String.format("%04d", this.value());
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || obj.getClass() != this.getClass()) {
            return false;
        }

        Clickable other = (Clickable) obj;
        return this.counter == other.counter;
    }

    @Override
    public int hashCode() {
        return Objects.hash(this.counter);
    }

    /*
     * Factory examples 
     * 
     * public static Clickable zero(){ return new Clickable(0); }
     * 
     * public static Clickable withValue(int value){ if (value < 0 || value > 9999){
     * throw new IllegalArgumentException("Value must be between 0 and " + 9999); }
     * 
     * return new Clickable(value); }
     */
}
