package waffle.com;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class App {
    /* Retourne une nouvelle liste où toutes les valeurs sont doublées */
    public static List<Integer> doubleThat(List<Integer> is){
        final List<Integer> result = new ArrayList<>();

        for (int i = 0; i < is.size(); i++) {
            result.add(is.get(i) * 2);
        }

        return result;
    }

    /* Retourne une nouvelle liste où toutes les valeurs sont plus grandes ou
    égale à un seuil */
    public static List<Integer> filterGreaterOrEqual(List<Integer> is, int value) {
        final List<Integer> result = new ArrayList<>();

        for (int i = 0; i < is.size(); i++) {
            int element = is.get(i);

            if (element >= value){
                result.add(element);
            }
        }

        return result;
    }

    /* Retourne une nouvelle liste où toutes les valeurs positives sont
    multipliées par deux. Les valeurs négatives sont omises */
    public static List<Integer> filterPositiveAndThenDoubleThem(List<Integer> is){
        final List<Integer> result = new ArrayList<>();

        for (int i = 0; i < is.size(); i++) {
            int element = is.get(i);

            // If our number is positive
            if (element >= 0){
                result.add(element * 2);
            }
        }

        return result;
    }

    public static void printList(List<Integer> is){
        for (Integer i : is) {
            System.out.println(i);
        }
        System.out.println("");
    }

    public static void main(String[] args) {
        List<Integer> list = Arrays.asList(-16, -8, -4, -2, 1, 2, 4, 8, 16, 32, 64, 128, 256);
        printList(list);
        list = doubleThat(list);
        printList(list);
        list = filterGreaterOrEqual(list, -16);
        printList(list);
        list = filterPositiveAndThenDoubleThem(list);
        printList(list);
    }
}
