package ch.hepia.mystery_number;

import java.util.Random;
import java.util.Scanner;

public class App {
    public static boolean isValidNumber(int userInput) {
        final int MAX = 100;
        final int MIN = 0;

        return (userInput > MAX || userInput < MIN) ? false : true;
    }

    public static void main(String[] args) {
        if (args.length > 0) {
            int maxNumberToGuess;
            Random rng = new Random();
            Scanner sc = new Scanner(System.in);

            int hiddenNumber;
            boolean hasBeenFound = false;
            int turnCount = 1;

            switch (args[0]) {
                case "help":
                    System.out.println("------------------------------------");
                    System.out.println("M Y S T E R Y  N U M B E R  G A M E");
                    System.out.println("------------------------------------");
                    System.out.println("Usage : ");
                    System.out.println("mystery-number.jar %d");
                    System.out.println("where %d is any integer number");
                    System.out.println(
                            "The computer will choose a random number between 0 and %d, you will have to find it.");
                    System.out.println("");
                    System.out.println("mystery-number.jar guess %d");
                    System.out.println("where %d is any integer number");
                    System.out.println("The computer will try and find your number between 0 and %d");
                    break;
                case "guess":
                    try {
                        maxNumberToGuess = Integer.parseInt(args[1]);
                        int currentCPUGuess = maxNumberToGuess / 2;
                        int searchRange = currentCPUGuess / 2;

                        while (!hasBeenFound) {
                            System.out.print("Sagit-il du : " + currentCPUGuess + " ? [o/+/-]");
                            char userAnswer = sc.nextLine().charAt(0);

                            switch (userAnswer) {
                                case '+':
                                    currentCPUGuess += searchRange;
                                    searchRange /= 2;
                                    break;
                                case '-':
                                    currentCPUGuess -= searchRange;
                                    searchRange /= 2;
                                    break;
                                case 'o':
                                    hasBeenFound = true;
                                    System.out.println("Yay ! La machine bat définitivement l'humain");
                                    break;
                                default:
                                    System.out.println("Please enter a valid character : [o/+/-]");
                                    break;
                            }
                        }

                    } catch (Exception e) {
                        throw new IllegalArgumentException("Input is not an integer.");
                    }
                    break;

                default:
                    try {
                        maxNumberToGuess = Integer.parseInt(args[0]);
                        hiddenNumber = rng.nextInt(maxNumberToGuess);

                        //System.out.println("[DEBUG] ANSWER IS : " + hiddenNumber);

                        while (!hasBeenFound) {
                            System.out.print("Entrez un nombre : ");
                            int currentGuess = sc.nextInt();

                            if (currentGuess == hiddenNumber) {
                                hasBeenFound = true;
                                System.out.println("Bravo vous avez trouvé le nombre en " + turnCount + " essais");
                            }

                            turnCount++;
                        }
                    } catch (Exception e) {
                        throw new IllegalArgumentException("Input is not an integer.");
                    }
                    break;
            }
        } else {
            throw new IllegalArgumentException(
                    "Arguments needs to be added to execute mystery number, ex:'24' or 'guess 212'.");
        }
    }
}
