package waffle.com;

public class Snake{
    private int lenght;
    private String head;

    public Snake(int startingSize) {
        // Clip the size to 1 at minimum
        int size = (startingSize < 1) ? 1 : startingSize;
        this.lenght = size;
    }

    public Snake(int startingSize, String snakeHead){
        this(startingSize);
        this.head = snakeHead;
    }


    public void increaseSize(){
        this.lenght++;
    }

    public void decreaseSize(){
        if(this.lenght > 1){
            this.lenght--;
        }
        else{
            // close the program if the snake ever reaches a size of 0
            System.out.print("Goodbye !");
            System.exit(0);
        }
    }

    /**
     * Executes an operation on the snake using a character
     * @param operation accepts only '+' or '-' as a valid operation.
     */
    public void execute(char operation){
        switch (operation) {
            case '+':
                this.increaseSize();
                break;

            case '-':
                this.decreaseSize();
                break;
            default:
                System.err.println("Invalid operation. Currently supported operations are '+' and '-'.");
                break;
        }
    }

    /**
     * Draws the snake in the terminal.
     */
    public void draw(){
        for (int i = 0; i < this.lenght; i++) {
            System.out.print("*");
        }
        System.out.print(this.head);
        System.out.println();
    }
}