package ch.hepia.exercice_3_1;
import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;

public class ContainerHelper {


    /**
     * Allows the creation of containers and the ability to fill them with a specified amount.
     * @param amount the amount to fill the container.
     * @param container the first (required) container.
     * @param otherContainers arbitrary amount of other containers
     * @return
     */
    public static List<Integer> transfer(int amount, int container, int... otherContainers){
        int amountLeft = amount;
        List<Integer> containers = new ArrayList<>();
        List<Integer> result = new ArrayList<>();

        // Concatenate our first required parameter and the arbiritrary amount of parameters into a list
        containers.add(container);
        Arrays.stream(otherContainers).forEach(i -> containers.add(i));

        for (int containerCapacity : containers) {
            // Fill the container to their max capacity if possible, else to the remaining amount
            result.add((amountLeft >= containerCapacity) ? containerCapacity : amountLeft);
            // Limit the remaining amount from going below zero while substracting
            amountLeft = (amountLeft - containerCapacity <= 0) ? 0 : amountLeft - containerCapacity;
        }

        return result;
    }
}
